<?php
/**
 * Created by PhpStorm.
 * User: geovanesantos
 * Date: 19/01/2015
 * Time: 11:09
 */

namespace Gestao\Facade;


class GesSearchFilialFacade {
    public static function makeCustomFilter(){

        //pega os valores nos campos de regional e supervisor
        $regionalList=tk_get_context_vars("P_CDAREAGERE");
        $supervisorList=tk_get_context_vars("P_CDSUPERVISOR");
        $grupFiliList=tk_get_context_vars("P_CDGRUPFILI");
        //pega o retorno do multisearch e transforma numa string, concatenada com virgulas
        //se o que voltar do get_field_value for "A" ou "N"(não faz sentido rodar o relatório com nenhum), retorna "T", de Todos
        $regionaisString=\Scheduler\Util\ReportParameterFunctions::getInfoFromMultiSearchString($regionalList, 'cdareagere');
        $supervisorString=\Scheduler\Util\ReportParameterFunctions::getInfoFromMultiSearchString($supervisorList, 'cdoperador');
        $grupFiliString=\Scheduler\Util\ReportParameterFunctions::getInfoFromMultiSearchString($grupFiliList, 'cdgrupfili');
        //embrulha cada um dos códigos da lista com aspas
        $wrappedRegionaisString="'".str_replace(",", "','", $regionaisString)."'";
        $wrappedSupervisorString="'".str_replace(",", "','", $supervisorString)."'";
        $wrappedGrupFiliString="'".str_replace(",", "','", $grupFiliString)."'";

        //a ideia é que $queryFilterClauses tem as condições WHERE da query usada no refsearch de filial
        //esse array vai ser implodido com "AND" e retornado como uma string

        //verificar essas condições
        $queryFilterClauses=Array();
        if($wrappedSupervisorString != "'T'"){
            $queryFilterClauses[]=" CDSUPERVISOR IN (".$wrappedSupervisorString.")";
        }

        if($wrappedRegionaisString != "'T'"){
            $queryFilterClauses[]=" CDAREAGERE IN(".$wrappedRegionaisString.")";
        }

        if($wrappedGrupFiliString != "'T'"){
            $queryFilterClauses[]=" EXISTS(
                            SELECT CDGRUPFILI FROM FILGRUPFILI F
                            WHERE FILIAL.CDFILIAL=F.CDFILIAL AND
                            F.CDGRUPFILI IN(".$wrappedGrupFiliString."))";
        }
        $queryFilter=implode('AND', $queryFilterClauses);
        //tk_message($queryFilter,'info');

        /*
        //a ideia é que essa string vai ser colocada no WHERE da query do refsearch de filial
        $queryFilter="(".$wrappedSupervisorString."='T' OR CDSUPERVISOR IN (".$wrappedSupervisorString."))
                        AND (".$wrappedRegionaisString."='T' OR CDAREAGERE IN(".$wrappedRegionaisString."))
                        AND EXISTS(
                            SELECT CDGRUPFILI FROM FILGRUPFILI F
                            WHERE CDGRUPFILI IN(".$wrappedGrupFiliString.") OR ".$wrappedGrupFiliString."=T);)";
        */
        return Array($queryFilter,"");
    }
} 